#pragma once


#include "WinHTTPWrappers.h"


class CMyDownloadFileWinHTTPRequest : public WinHTTPWrappers::CSyncDownloader
{
protected:
//Methods
  HRESULT OnCallback(_In_ HINTERNET hInternet, _In_ DWORD dwInternetStatus, _In_opt_ LPVOID lpvStatusInformation, _In_ DWORD dwStatusInformationLength) override;
  HRESULT OnCallbackComplete(_In_ HRESULT hr, _In_ HINTERNET hInternet, _In_ DWORD dwInternetStatus, _In_opt_ LPVOID lpvStatusInformation, _In_ DWORD dwStatusInformationLength) override;
};

class CTestWinHTTPWrappersDlg : public CDialog
{
//Construction
public:
  CTestWinHTTPWrappersDlg(CWnd* pParent = nullptr);

//Dialog Data
  enum { IDD = IDD_WINHTTPWRAPPERSSAMPLE_DIALOG };

//Methods
  void SetStatusText(LPCTSTR pszStatus);
  void UpdateStatusText(LPCTSTR pszStatus);

protected:
  void DoDataExchange(CDataExchange* pDX) override;

//Implementation
protected:
  enum ConnectionType
  {
    UsePreConfig,
    DirectToInternet,
    UseProxy,
  };

//Member variables
  HICON m_hIcon;
  CString m_sURL;
  CString m_sFileToDownload;
  CString m_sFileToUpload;
  bool m_bDownloading;
  CString m_sHTTPPassword;
  CString m_sProxyPassword;
  CString m_sHTTPUserName;
  CString m_sProxyUserName;
  DWORD m_dwOffset;
  int m_nConnection;
  CString m_sProxyServer;
  CString m_sVerb;
  double m_dbLimit;
  BOOL m_bNoURLRedirect;
  CString m_sAcceptTypes;
  BOOL m_bHTTPPreauthentication;
  BOOL m_bProxyPreauthentication;
  CString m_sReferrer;
  int m_nHTTPPreauth;
  int m_nProxyPreauth;
  BOOL m_bAsync;
  CEdit m_wndStatus;
  WinHTTPWrappers::CSession m_session;
  CMyDownloadFileWinHTTPRequest m_request;
  WinHTTPWrappers::CConnection  m_connection;

//Methods
  BOOL OnInitDialog() override;
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnBnClickedDownload();
  afx_msg LRESULT OnDownloadComplete(WPARAM wParam, LPARAM lParam);

  DECLARE_MESSAGE_MAP()
};
